﻿//////////////////////////////////////////////
// ConsoleOutputFormatter.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkDebug
{
	struct TestClassObserverInformation ;
	struct TestFunctionObserverInformation ;
}

/// Includes ---------------------------------

// nkDebug
#include "../../Dll/DllDefines.h"

#include "OutputFormatter.h"

/// Class ------------------------------------

namespace nkDebug
{
	class DLL_NKDEBUG_EXPORT ConsoleOutputFormatter final : public OutputFormatter
	{
		public :

			// Constructor, destructor
			ConsoleOutputFormatter () ;
			virtual ~ConsoleOutputFormatter () ;

			// Formatting
			virtual nkLog::String formatClassLaunch (const TestClassObserverInformation& info) override ;
			virtual nkLog::String formatClassBypass (const TestClassObserverInformation& info) override ;
			virtual nkLog::String formatClassEnd (const TestClassObserverInformation& info) override ;
			virtual nkLog::String formatTestLaunch (const TestFunctionObserverInformation& info) override ;
			virtual nkLog::String formatTestBypass (const TestFunctionObserverInformation& info) override ;
			virtual nkLog::String formatTestSuccess (const TestFunctionObserverInformation& info) override ;
			virtual nkLog::String formatTestFailure (const TestFunctionObserverInformation& info) override ;
	} ;
}