﻿//////////////////////////////////////////////
// TestObserver.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkDebug
{
	struct TestClassObserverInformation ;
	struct TestFunctionObserverInformation ;
}

/// Includes ---------------------------------

// nkDebug
#include "../../Dll/DllDefines.h"

// nkLog
#include <NilkinsLog/Data/StringView.h>

/// Class ------------------------------------

namespace nkDebug
{
	class DLL_NKDEBUG_EXPORT TestObserver
	{
		public  :

			// Functions
			// Constructor, destructor
			TestObserver () ;
			virtual ~TestObserver () ;

			// Hooks
			virtual void onClassLaunch (const TestClassObserverInformation& info) ;
			virtual void onClassBypass (const TestClassObserverInformation& info) ;
			virtual void onClassEnd (const TestClassObserverInformation& info) ;
			virtual void onTestLaunch (const TestFunctionObserverInformation& info) ;
			virtual void onTestBypass (const TestFunctionObserverInformation& info) ;
			virtual void onTestSuccess (const TestFunctionObserverInformation& info) ;
			virtual void onTestFailure (const TestFunctionObserverInformation& info) ;
	} ;
}