﻿//////////////////////////////////////////////
// ComputePass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Shader ;
}

/// Includes ---------------------------------

// nkGraphics
#include "Pass.h"

#include "../Dll/DllDefines.h"
	
/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ComputePass : public Pass
	{
		protected :

			// Attributs
			// Shader lié
			Shader* _linkedShader ;

			// Infos de thread
			unsigned int _xThreads ;
			unsigned int _yThreads ;
			unsigned int _zThreads ;

		protected :

			// Functions
			// Constructor, destructor
			ComputePass () ;
			virtual ~ComputePass () ;
		
		public :
		
			// Getters
			Shader* getLinkedShader () const ;
			unsigned int getX () const ;
			unsigned int getY () const ;
			unsigned int getZ () const ;

			// Setters
			void setLinkedShader (Shader* shader) ;
			void setX (unsigned int value) ;
			void setY (unsigned int value) ;
			void setZ (unsigned int value) ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}