﻿//////////////////////////////////////////////
// ThemeManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward Decl -----------------------------

namespace nkWinUi
{
	class Theme ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <memory>
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT ThemeManager final : public nkCommon::SingletonClass<ThemeManager>
	{
		friend class nkCommon::SingletonClass<ThemeManager> ;

		private :

			// Les thèmes qu'on a en réserve
			std::unordered_map<std::string, Theme*> _themes ;

			// Le thème actif
			Theme* _activeTheme ;

		private :
	
			// Constructor, destructor
			ThemeManager () ;
			~ThemeManager () ;

		public :

			// Manipulations
			Theme* createOrRetrieve (const nkMemory::StringView& name) ;
			Theme* get (const nkMemory::StringView& name) const ;

			// Getters
			Theme* getActiveTheme () const ;

			// Setters
			void setActiveTheme (Theme* theme) ;
	} ;
}