﻿//////////////////////////////////////////////
// StructToString.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	enum class RELATIVE_POSITION ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Components/ComponentType.h"

#include "../Layouts/LayoutType.h"

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>

/// Class ------------------------------------

namespace nkWinUi
{
	class StructToString
	{
		private :

			// Functions
			// Constructeur, destructeur
			StructToString () = delete ;
			~StructToString () = delete ;

		public :

			// Components
			static const nkMemory::StringView getStringFromComponentType (COMPONENT_TYPE type) ;
			static COMPONENT_TYPE getComponentTypeFromString (const nkMemory::StringView& name) ;

			// Layouts
			static const nkMemory::StringView getStringFromLayoutType (LAYOUT_TYPE type) ;
			static LAYOUT_TYPE getLayoutTypeFromString (const nkMemory::StringView& name) ;
	} ;
}